#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <fcntl.h>
#include <linux/types.h>
#include <asm-generic/mman-common.h>
#include <linux/fb.h>

#define FB_DEVICE "/dev/fb0"            //  FB foCX

static int fb_fd;
static volatile unsigned char *fb_mem = NULL;

//  fb_init: FB iŏɂP񂾂ĂяoƁj
void fb_init (int *fb_width, int *fb_height)
{
    int ret;
    //  t[obt@ /dev/fb0 Jisudo Kvj
    fb_fd = open(FB_DEVICE, O_RDWR);
    if (fb_fd < 0) {
        printf("error: cannot open %s (fb_init)\n", FB_DEVICE);
        exit(-1);
    }
    //  ʏ擾E`FbN
    struct fb_var_screeninfo sinfo;
    ret = ioctl(fb_fd, FBIOGET_VSCREENINFO, &sinfo);
    if (ret < 0) {
        printf("error: cannot get var screen info (fb_init)\n");
              exit(-1);
    }
    printf("fb_width  : %d\n", sinfo.xres);
    printf("fb_height : %d\n", sinfo.yres);
    *fb_width   = sinfo.xres;
    *fb_height  = sinfo.yres;
    if (sinfo.bits_per_pixel != 16) {
        //  16bit łȂ΃G[
        printf("error: the frame buffer is not 16bpp (fb_init)\n");
        exit(1);
    }
    struct fb_fix_screeninfo finfo;
    ret = ioctl(fb_fd, FBIOGET_FSCREENINFO, &finfo);
    if (ret < 0) {
        printf("error: cannot get fix screen info (fb_init)\n");
        exit(-1);
    }
    printf("fb_linelen: %d\n", finfo.line_length);
    if (finfo.line_length != sinfo.xres * 2) {
        //  PC̒؂ȂƃG[î߁j
        printf("error: line length must be width*2 (fb_init)\n");
        exit(-1);
    }
    //  /dev/fb0  mmap
    int fb_size = sinfo.xres * sinfo.yres * 2;
    fb_mem = (unsigned char *)
        mmap(NULL, fb_size, PROT_READ | PROT_WRITE, MAP_SHARED, fb_fd, 0);
    if (fb_mem == NULL) {
        printf("error: cannot map /dev/mem on the memory (fb_init)\n");
        exit(-1);
    }
}
//  fb_get: t[obt@̓e擾
unsigned char *fb_get ()
{
    //  t[obt@ւ̃|C^Ԃ
    return (unsigned char *) fb_mem;
}
